require 'securerandom'
module Lightning
  module Bolt
    class Fuzzer

      def initialize(encoder)
        @encoder = encoder
        @alphabet = alphabet()
      end

      def random_number(min,max)
        return SecureRandom.random_number(max-min)+min
      end

      def random_character(size)
        enigma = ""
        while (enigma.size < size + 1)
          char = @alphabet[random_number(0,@alphabet.size)]
          if char
            enigma += char
          end
        end
        return enigma
      end

      private

      def alphabet
        charset = []
        0.upto(1112064) do |i|
          char = nil
          begin
            char = "" << i
          rescue
          end
          if !char.eql?(nil)
            if encodable?(char)
              charset.push(char.encode(@encoder))
            end
          end
        end
        return charset
      end

      def encodable?(rotar)
        begin
          rotar.encode(@encoder)
          return true
        rescue Encoding::UndefinedConversionError
          return false
        end
      end
    end
  end
end
